=== debian/changelog ===
ros-indigo-micros-swarm-framework (0.0.14-0trusty) trusty; urgency=high

  * complete neighbor communication
  * simplify the user interface functions
  * improve the security of multi-threading
  * limit communication range
  * add PacketParser class
  * performance optimization
  * optimize the RuntimePlatformKernel

 -- Xuefeng Chang <changxuefengcn@163.com>  Thu, 08 Sep 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.13-0trusty) trusty; urgency=high

  * improve neighbor communication mechanism, add Broadcaster and Listener class
  * add Application class, which is convenient for users to develop app
  * change cmake file
  * change README file
  * repair bugs in app2

 -- Xuefeng Chang <changxuefengcn@163.com>  Mon, 15 Aug 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.12-0trusty) trusty; urgency=high

  * reconstructe the whole architecture using nodelet to improve performance
  * is extensible to Opensplice DDS
  * add neighbor communication mechanism
  * standard the interface definition
  * repair bugs in cmake file

 -- Xuefeng Chang <changxuefengcn@163.com>  Sun, 17 Jul 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.11-0trusty) trusty; urgency=high

  * repair bugs in cmake file

 -- Xuefeng Chang <changxuefengcn@163.com>  Sun, 17 Jul 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.10-0trusty) trusty; urgency=high

  * reconstructe the whole architecture using nodelet to improve performance
  * is extensible to Opensplice DDS
  * add neighbor communication mechanism
  * standard the interface definition

 -- Xuefeng Chang <changxuefengcn@163.com>  Sun, 17 Jul 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.9-0trusty) trusty; urgency=high

  * Add another experiment which is called "Flocking"
  * Add linear velocity in the Base and NeighborBase classes
  * Add the breakupSwarm function in the "swarm.h" header

 -- Xuefeng Chang <changxuefengcn@163.com>  Wed, 06 Jul 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.8-0trusty) trusty; urgency=high

  * No longer using the TCP protocol in ROS, UDP protocol is used instead
  * Location class defined in the "data_type.h" header is renamed to Base
  * NeighborLocation class defined in the "data_type.h" header is renamed to NeighborBase

 -- Xuefeng Chang <changxuefengcn@163.com>  Mon, 13 Jun 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.7-0trusty) trusty; urgency=high

  * optimize the installation

 -- Xuefeng Chang <changxuefengcn@163.com>  Sun, 29 May 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.6-0trusty) trusty; urgency=high

  * optimize the kernel code
  * change the readme file

 -- Xuefeng Chang <changxuefengcn@163.com>  Mon, 16 May 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.5-0trusty) trusty; urgency=high

  * change the license to BSD
  * perfect the package information
  * optimize the kernel
  * optimize code structure
  * simplify synchronization protocol

 -- Xuefeng Chang <changxuefengcn@163.com>  Thu, 12 May 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.4-0trusty) trusty; urgency=high

  * repair the cmake bug

 -- Xuefeng Chang <changxuefengcn@163.com>  Tue, 10 May 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.3-0trusty) trusty; urgency=high

  * repair the headers bug

 -- Xuefeng Chang <changxuefengcn@163.com>  Tue, 10 May 2016 16:00:00 -0000

ros-indigo-micros-swarm-framework (0.0.2-0trusty) trusty; urgency=high

  * version 1.0
  * Contributors: xuefengchang

 -- Xuefeng Chang <changxuefengcn@163.com>  Mon, 09 May 2016 16:00:00 -0000
