=== debian/control ===
Source: ros-indigo-micros-swarm-framework
Section: misc
Priority: extra
Maintainer: Xuefeng Chang <changxuefengcn@163.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-geometry-msgs, ros-indigo-message-generation, ros-indigo-nav-msgs, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-std-msgs
Homepage: http://wiki.ros.org/micros_swarm_framework
Standards-Version: 3.9.2

Package: ros-indigo-micros-swarm-framework
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-geometry-msgs, ros-indigo-message-runtime, ros-indigo-nav-msgs, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-std-msgs
Description: This is a programming framework to facilitate application development involving robot swarms.
 It makes coding for swarms much easier by providing an adequate swarm-level abstraction, as well as tools for swarm management, various communication mechanisms and so on. It also provides essential data structures, such as Neighbor, Swarm, and Virtual Stigmergy, to the user. Most importantly, it is completely compatible with ROS Indigo and presented in the form of a C++ library, which means that all resources in the ROS ecosystem are still available to the user. It is currently extensible to Opensplice DDS.
